module Aginx
  module Generators
    class SerializerGenerator < Rails::Generators::NamedBase
      source_root File.expand_path('../templates', __FILE__)

      def create_serializer
        prepare
        template 'serializer.rb', File.join('app/serializers', class_path, "#{file_name}_serializer.rb")
      end

      private

      def prepare
        set_model
      end

      def set_model
        @model_table_name = file_name.underscore.pluralize
        @model_name = file_name.camelize.singularize
        if args.length == 0
          model = @model_name.constantize
          if model.respond_to? :columns
            @model_columns = model.columns.map{|column| "#{column.name}"}
          else
            raise "未找到#{model}相关表结构信息"
          end
        else
          @model_columns = args.map{|arg| arg.split(':')[0]}
        end
      end

    end
  end
end
